From 2020eb84b5bf565c049698439f1a8ae76de985c6 Mon Sep 17 00:00:00 2001
From: Tomohiro Kusumi <tkusumi@netbsd.org>
Date: Mon, 6 Dec 2021 01:23:39 +0900
Subject: [PATCH] ext2fs: Remove sys/gnu/vfs/ext2fs and make sys/vfs/ext2fs the
 default

This commit removes the old+unstable GPL ext2 implementation,
and makes the new FreeBSD based ext2 implementation the default.

- Remove sys/gnu/vfs.
- Rename sys/vfs/ext2fs/ext2fs_freebsd.ko -> ext2fs.ko.
- Modify unusual userspace program which includes kernel struct.
- Bump __DragonFly_version to 600107.
---
 etc/mtree/BSD.include.dist             |    8 +-
 include/Makefile                       |    3 +-
 lib/libfsid/ext2.c                     |   28 +-
 sys/conf/files                         |   28 +-
 sys/gnu/Makefile                       |    2 +-
 sys/gnu/vfs/Makefile                   |    3 -
 sys/gnu/vfs/ext2fs/COPYRIGHT.INFO      |   54 -
 sys/gnu/vfs/ext2fs/Makefile            |   10 -
 sys/gnu/vfs/ext2fs/dinode.h            |  133 --
 sys/gnu/vfs/ext2fs/dir.h               |  157 --
 sys/gnu/vfs/ext2fs/ext2_alloc.c        |  535 ------
 sys/gnu/vfs/ext2fs/ext2_balloc.c       |  311 ----
 sys/gnu/vfs/ext2fs/ext2_bitops.h       |  114 --
 sys/gnu/vfs/ext2fs/ext2_bmap.c         |  336 ----
 sys/gnu/vfs/ext2fs/ext2_extern.h       |  121 --
 sys/gnu/vfs/ext2fs/ext2_fs.h           |  634 --------
 sys/gnu/vfs/ext2fs/ext2_fs_sb.h        |   84 -
 sys/gnu/vfs/ext2fs/ext2_ihash.c        |  210 ---
 sys/gnu/vfs/ext2fs/ext2_inode.c        |  573 -------
 sys/gnu/vfs/ext2fs/ext2_inode_cnv.c    |  136 --
 sys/gnu/vfs/ext2fs/ext2_linux_balloc.c |  622 -------
 sys/gnu/vfs/ext2fs/ext2_linux_ialloc.c |  515 ------
 sys/gnu/vfs/ext2fs/ext2_linux_super.c  |  133 --
 sys/gnu/vfs/ext2fs/ext2_lookup.c       | 1045 ------------
 sys/gnu/vfs/ext2fs/ext2_mount.h        |  120 --
 sys/gnu/vfs/ext2fs/ext2_quota.c        |  925 -----------
 sys/gnu/vfs/ext2fs/ext2_readwrite.c    |  291 ----
 sys/gnu/vfs/ext2fs/ext2_subr.c         |   83 -
 sys/gnu/vfs/ext2fs/ext2_vfsops.c       | 1241 --------------
 sys/gnu/vfs/ext2fs/ext2_vnops.c        | 2079 ------------------------
 sys/gnu/vfs/ext2fs/fs.h                |  198 ---
 sys/gnu/vfs/ext2fs/inode.h             |  159 --
 sys/gnu/vfs/ext2fs/quota.h             |  200 ---
 sys/sys/param.h                        |    3 +-
 sys/vfs/ext2fs/Makefile                |    2 +-
 usr.bin/fstat/ext2fs.c                 |    6 +-
 36 files changed, 40 insertions(+), 11062 deletions(-)
 delete mode 100644 sys/gnu/vfs/Makefile
 delete mode 100644 sys/gnu/vfs/ext2fs/COPYRIGHT.INFO
 delete mode 100644 sys/gnu/vfs/ext2fs/Makefile
 delete mode 100644 sys/gnu/vfs/ext2fs/dinode.h
 delete mode 100644 sys/gnu/vfs/ext2fs/dir.h
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_alloc.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_balloc.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_bitops.h
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_bmap.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_extern.h
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_fs.h
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_fs_sb.h
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_ihash.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_inode.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_inode_cnv.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_linux_balloc.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_linux_ialloc.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_linux_super.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_lookup.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_mount.h
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_quota.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_readwrite.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_subr.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_vfsops.c
 delete mode 100644 sys/gnu/vfs/ext2fs/ext2_vnops.c
 delete mode 100644 sys/gnu/vfs/ext2fs/fs.h
 delete mode 100644 sys/gnu/vfs/ext2fs/inode.h
 delete mode 100644 sys/gnu/vfs/ext2fs/quota.h

diff --git a/etc/mtree/BSD.include.dist b/etc/mtree/BSD.include.dist
index b6db5dadbc..8393b342a2 100644
--- a/etc/mtree/BSD.include.dist
+++ b/etc/mtree/BSD.include.dist
@@ -235,12 +235,6 @@
             ..
         ..
     ..
-    gnu
-        vfs
-            ext2fs
-            ..
-        ..
-    ..
     libprop
     ..
     lzma
@@ -444,6 +438,8 @@
     vfs
         autofs
         ..
+        ext2fs
+        ..
         hammer
         ..
         hammer2
diff --git a/include/Makefile b/include/Makefile
index 27f27f7311..ef8db61450 100644
--- a/include/Makefile
+++ b/include/Makefile
@@ -65,7 +65,6 @@ LSUBDIRS= \
 	dev/smbus/smb \
 	dev/video/bktr dev/video/meteor \
 	dev/virtual/nvmm dev/virtual/nvmm/x86 \
-	gnu/vfs/ext2fs \
 	libprop \
 	net/bridge net/tap net/tun net/ppp_layer net/sl \
 	net/pf net/altq \
@@ -92,7 +91,7 @@ LSUBDIRS= \
 	vfs/isofs/cd9660 \
 	vfs/msdosfs vfs/nfs vfs/ntfs \
 	vfs/smbfs vfs/udf vfs/ufs vfs/hammer vfs/hammer2 \
-	vfs/autofs vfs/fuse vfs/tmpfs
+	vfs/autofs vfs/fuse vfs/tmpfs vfs/ext2fs
 
 # For SHARED=symlinks, adjust LSYMSUBDIRS to remove subdirectories whos
 # parent directory is also symlinked, avoiding the source tree being
diff --git a/lib/libfsid/ext2.c b/lib/libfsid/ext2.c
index 68391f3824..6ac90668e4 100644
--- a/lib/libfsid/ext2.c
+++ b/lib/libfsid/ext2.c
@@ -32,24 +32,28 @@
  * SUCH DAMAGE.
  */
 
-#include <gnu/vfs/ext2fs/ext2_fs.h>
-#include <gnu/vfs/ext2fs/fs.h>
-
 #include "libfsid.h"
 
-static char buffer[sizeof(struct ext2_super_block)*2];
+#include <vfs/ext2fs/ext2fs.h>
+#include <vfs/ext2fs/fs.h>
+
+/*
+ * struct ext2fs is actually ext4 compatible,
+ * whereas it used to be using the real ext2 superblock struct.
+ */
+static char buffer[sizeof(struct ext2fs)*2];
 
 fsid_t
 ext2_probe(const char *dev)
 {
-	static struct ext2_super_block *fs;
+	static struct ext2fs *fs;
 
 	if (fsid_dev_read(dev, SBOFF, sizeof(buffer), buffer) != 0)
 		return FSID_UNKNOWN;
 
-	fs = (struct ext2_super_block *)&buffer;
+	fs = (struct ext2fs *)&buffer;
 
-	if (fs->s_magic == EXT2_SUPER_MAGIC)
+	if (fs->e2fs_magic == E2FS_MAGIC)
 		return FSID_EXT2;
 
 	return FSID_UNKNOWN;
@@ -58,17 +62,17 @@ ext2_probe(const char *dev)
 char *
 ext2_volname(const char *dev)
 {
-	static struct ext2_super_block *fs;
+	static struct ext2fs *fs;
 
 	if (fsid_dev_read(dev, SBOFF, sizeof(buffer), buffer) != 0)
 		return NULL;
 
-	fs = (struct ext2_super_block *)&buffer;
+	fs = (struct ext2fs *)&buffer;
 
-	if (fs->s_magic != EXT2_SUPER_MAGIC || fs->s_volume_name[0] == '\0')
+	if (fs->e2fs_magic != E2FS_MAGIC || fs->e2fs_vname[0] == '\0')
 		return NULL;
 
-	fs->s_volume_name[sizeof(fs->s_volume_name) - 1] = '\0';
+	fs->e2fs_vname[sizeof(fs->e2fs_vname) - 1] = '\0';
 
-	return fs->s_volume_name;
+	return fs->e2fs_vname;
 }
diff --git a/sys/conf/files b/sys/conf/files
index 7df20ff711..180698d801 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -1309,20 +1309,20 @@ wpi.fw			optional wpifw					\
 	clean		"wpi.fw"
 dev/netif/xe/if_xe.c			optional xe
 dev/netif/xe/if_xe_pccard.c		optional xe pccard
-gnu/vfs/ext2fs/ext2_alloc.c		optional ext2fs
-gnu/vfs/ext2fs/ext2_balloc.c		optional ext2fs
-gnu/vfs/ext2fs/ext2_bmap.c		optional ext2fs
-gnu/vfs/ext2fs/ext2_inode.c		optional ext2fs
-gnu/vfs/ext2fs/ext2_inode_cnv.c		optional ext2fs
-gnu/vfs/ext2fs/ext2_linux_balloc.c	optional ext2fs
-gnu/vfs/ext2fs/ext2_linux_ialloc.c	optional ext2fs
-gnu/vfs/ext2fs/ext2_linux_super.c	optional ext2fs
-gnu/vfs/ext2fs/ext2_lookup.c		optional ext2fs
-gnu/vfs/ext2fs/ext2_subr.c		optional ext2fs
-gnu/vfs/ext2fs/ext2_vfsops.c		optional ext2fs
-gnu/vfs/ext2fs/ext2_vnops.c		optional ext2fs
-gnu/vfs/ext2fs/ext2_ihash.c		optional ext2fs
-gnu/vfs/ext2fs/ext2_quota.c		optional ext2fs
+vfs/ext2fs/ext2_alloc.c			optional ext2fs
+vfs/ext2fs/ext2_balloc.c		optional ext2fs
+vfs/ext2fs/ext2_bmap.c			optional ext2fs
+vfs/ext2fs/ext2_inode.c			optional ext2fs
+vfs/ext2fs/ext2_inode_cnv.c		optional ext2fs
+vfs/ext2fs/ext2_linux_balloc.c		optional ext2fs
+vfs/ext2fs/ext2_linux_ialloc.c		optional ext2fs
+vfs/ext2fs/ext2_linux_super.c		optional ext2fs
+vfs/ext2fs/ext2_lookup.c		optional ext2fs
+vfs/ext2fs/ext2_subr.c			optional ext2fs
+vfs/ext2fs/ext2_vfsops.c		optional ext2fs
+vfs/ext2fs/ext2_vnops.c			optional ext2fs
+vfs/ext2fs/ext2_ihash.c			optional ext2fs
+vfs/ext2fs/ext2_quota.c			optional ext2fs
 vfs/isofs/cd9660/cd9660_bmap.c	optional cd9660
 vfs/isofs/cd9660/cd9660_lookup.c	optional cd9660
 vfs/isofs/cd9660/cd9660_node.c	optional cd9660
diff --git a/sys/gnu/Makefile b/sys/gnu/Makefile
index 4ac270dcf1..c5d1770f9a 100644
--- a/sys/gnu/Makefile
+++ b/sys/gnu/Makefile
@@ -1,3 +1,3 @@
-SUBDIR=	dev vfs
+SUBDIR=	dev
 
 .include <bsd.subdir.mk>
diff --git a/sys/sys/param.h b/sys/sys/param.h
index d78e21ac9f..150b517347 100644
--- a/sys/sys/param.h
+++ b/sys/sys/param.h
@@ -235,9 +235,10 @@
  * 600104 - add posix_fallocate()
  * 600105 - add fdatasync()
  * 600106 - msdosfs support in makefs(8)
+ * 600107 - remove sys/gnu/vfs/ext2fs
  */
 #undef __DragonFly_version
-#define __DragonFly_version 600106	/* propagated to newvers */
+#define __DragonFly_version 600107	/* propagated to newvers */
 
 #include <sys/_null.h>
 
diff --git a/sys/vfs/ext2fs/Makefile b/sys/vfs/ext2fs/Makefile
index 53fa01a7da..f1beff9e2f 100644
--- a/sys/vfs/ext2fs/Makefile
+++ b/sys/vfs/ext2fs/Makefile
@@ -1,4 +1,4 @@
-KMOD=	ext2fs_freebsd
+KMOD=	ext2fs
 SRCS=	ext2_alloc.c ext2_balloc.c ext2_bmap.c ext2_csum.c ext2_extents.c ext2_hash.c ext2_htree.c ext2_ihash.c ext2_inode.c ext2_inode_cnv.c ext2_lookup.c ext2_subr.c ext2_vfsops.c ext2_vnops.c
 
 .include <bsd.kmod.mk>
diff --git a/usr.bin/fstat/ext2fs.c b/usr.bin/fstat/ext2fs.c
index 35dbdef02e..9045503d0c 100644
--- a/usr.bin/fstat/ext2fs.c
+++ b/usr.bin/fstat/ext2fs.c
@@ -32,8 +32,8 @@
 #define _KERNEL_STRUCTURES
 #include <sys/vnode.h>
 #include <sys/mount.h>
-#include <gnu/vfs/ext2fs/quota.h>
-#include <gnu/vfs/ext2fs/inode.h>
+#include <vfs/ext2fs/inode.h>
+#define VTOI(vp)	((struct inode *)(vp)->v_data)
 #undef _KERNEL_STRUCTURES
 
 #include <stdio.h>
@@ -53,7 +53,7 @@ ext2fs_filestat(struct vnode *vp, struct filestat *fsp)
 	}
 	fsp->mode = ino.i_mode | mtrans(vp->v_type);
 	fsp->rdev = fsp->fsid = fstat_dev2udev(ino.i_dev);
-	fsp->size = ino.i_din.di_size;
+	fsp->size = ino.i_size;
 	fsp->fileid = ino.i_number;
 
 	return 1;
-- 
2.28.0

